#include <string.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define MAXTILES 9216
#define MAXTILEFILES 256

long artversion, takernum;
static char *pic = NULL;
static char artfilename[20];
static long localtilestart[MAXTILEFILES], localtileend[MAXTILEFILES];
static long numtilefiles;
static short tilesizx[MAXTILES], tilesizy[MAXTILES];
static long numtiles, picanm[MAXTILES], waloff[MAXTILES];
char picsiz[MAXTILES], tilefilenum[MAXTILES];
static long walsiz[MAXTILES], tilefileoffs[MAXTILES];

long cachesize = 0, artsize = 0;
static long cachelistplc, cachelistend, cacheplc;
static long cachelist[MAXTILES], cachelistoffs[MAXTILES];

main()
{
	char filename[20];
	long i, j, k, tilesperfile;

	printf("Re-sizeing art files...\n");
	printf("The new art files will be saved as tilen###.art so you will have\n");
	printf("   to do some renaming to use the new files.\n");
	printf("When you are sure you want to keep the new files, just type this:\n");
	printf("   del tiles*.art\n");
	printf("   ren tilen???.art tiles???.art\n");
	printf("How many tiles do you want per tiles###.art file?\n");
	scanf("%ld",&tilesperfile);
	printf("You chose %ld tiles per file\n",tilesperfile);

	loadpics("tiles000.art");

	strcpy(filename,"tilen000.art");
	j = 0; k = 0;
	for(i=0;i<localtileend[numtilefiles-1];i+=tilesperfile)
	{
		savepics(filename,k,k+tilesperfile-1);
		k += tilesperfile;
		j++;

		filename[7] = (j%10)+48;
		filename[6] = ((j/10)%10)+48;
		filename[5] = ((j/100)%10)+48;
	}
}

initcache()
{
	long i;

	for(i=0;i<MAXTILES;i++)
		waloff[i] = 0;

	cachelistplc = 0;
	cachelistend = 0;
	cacheplc = 0;
}

allocache (short tilenume)
{
	if (cacheplc+walsiz[tilenume] > cachesize)
	{
		while ((cachelistoffs[cachelistplc] >= cacheplc) && (cachelistplc != cachelistend))
		{
			waloff[cachelist[cachelistplc]] = 0;
			cachelistplc = ((cachelistplc+1)&(MAXTILES-1));
		}
		while ((cachelistoffs[cachelistplc] < walsiz[tilenume]) && (cachelistplc != cachelistend))
		{
			waloff[cachelist[cachelistplc]] = 0;
			cachelistplc = ((cachelistplc+1)&(MAXTILES-1));
		}

		waloff[tilenume] = FP_OFF(pic);
		cacheplc = walsiz[tilenume];
	}
	else
	{
		while ((cachelistoffs[cachelistplc] < cacheplc+walsiz[tilenume]) && (cachelistoffs[cachelistplc] >= cacheplc) && (cachelistplc != cachelistend))
		{
			waloff[cachelist[cachelistplc]] = 0;
			cachelistplc = ((cachelistplc+1)&(MAXTILES-1));
		}

		waloff[tilenume] = cacheplc+FP_OFF(pic);
		cacheplc += walsiz[tilenume];
	}

	cachelist[cachelistend] = tilenume;
	cachelistoffs[cachelistend] = waloff[tilenume];
	cachelistend = ((cachelistend+1)&(MAXTILES-1));
}

loadtile (short tilenume)
{
	char *ptr;
	long fil, i, otakernum;

	if ((walsiz[tilenume] <= 0) || (waloff[tilenume] != 0))
		return;

	otakernum = takernum; takernum = 9;

	i = tilefilenum[tilenume];
	artfilename[7] = (i%10)+48;
	artfilename[6] = ((i/10)%10)+48;
	artfilename[5] = ((i/100)%10)+48;
	if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
	{
		allocache(tilenume);
		lseek(fil,tilefileoffs[tilenume],SEEK_SET);
		ptr = (char *)waloff[tilenume];
		read(fil,ptr,walsiz[tilenume]);
		close(fil);
	}

	takernum = otakernum;
	return;
}

loadpics(char filename[20])
{
	long offscount, siz;
	short int fil, i, j, k;

	for(i=0;i<MAXTILES;i++)
		walsiz[i] = 0;
	initcache();

	strcpy(artfilename,filename);

	for(i=0;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}

	artsize = 0L;

	numtilefiles = 0;
	do
	{
		k = numtilefiles;

		artfilename[7] = (k%10)+48;
		artfilename[6] = ((k/10)%10)+48;
		artfilename[5] = ((k/100)%10)+48;
		if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
		{
			read(fil,&artversion,4);
			if (artversion != 1) return(-1);
			read(fil,&numtiles,4);
			read(fil,&localtilestart[k],4);
			read(fil,&localtileend[k],4);
			read(fil,&tilesizx[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&tilesizy[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&picanm[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<2);

			offscount = 4+4+4+4+((localtileend[k]-localtilestart[k]+1)<<3);
			for(i=localtilestart[k];i<=localtileend[k];i++)
			{
				tilefilenum[i] = k;
				tilefileoffs[i] = offscount;
				walsiz[i] = (long)(tilesizx[i]*tilesizy[i]);
				offscount += walsiz[i];
				artsize += walsiz[i];
			}
			close(fil);

			numtilefiles++;
		}
	}
	while (k != numtilefiles);

	cachesize = artsize;
	while ((pic = (char *)malloc(cachesize)) == NULL)
		cachesize -= 65536L;

	for(i=0;i<MAXTILES;i++)
	{
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizx[i]))
			j--;
		picsiz[i] = ((char)j);
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizy[i]))
			j--;
		picsiz[i] += ((char)(j<<4));
	}

	return(0);
}

savepics(char filename[20], long localtilestart, long localtileend)
{
	long templong, offscount, siz;
	short int fil, i, saveit;

	if (localtilestart > localtileend)
		return(0);

	numtiles = 4095L;
	while ((tilesizx[numtiles] < 2) && (tilesizy[numtiles] < 2) && (numtiles > 0))
		numtiles--;
	numtiles++;

	if (localtilestart >= MAXTILES)
		return(0);
	if (localtileend >= MAXTILES)
		localtileend = MAXTILES-1;

	saveit = 0;
	for(i=localtilestart;i<MAXTILES;i++)
	{
		if ((tilesizx[i]|tilesizy[i]) != 0)
		{
			saveit = 1;
			break;
		}
	}
	if (saveit == 0)
		return(0);

	printf("Saving %s (Tiles %d to %d)\n",filename,localtilestart,localtileend);

	if ((fil = open(filename,O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IWRITE))==-1)
		return(-1);
	write(fil,&artversion,4);
	write(fil,&numtiles,4);
	write(fil,&localtilestart,4);
	write(fil,&localtileend,4);
	write(fil,&tilesizx[localtilestart],(localtileend-localtilestart+1)<<1);
	write(fil,&tilesizy[localtilestart],(localtileend-localtilestart+1)<<1);
	write(fil,&picanm[localtilestart],(localtileend-localtilestart+1)<<2);

	offscount = 0L;
	for(i=0;i<localtilestart;i++)
		offscount += tilesizx[i]*tilesizy[i];
	for(i=localtilestart;i<=localtileend;i++)
	{
		siz = tilesizx[i]*tilesizy[i];
		if (siz > 0)
		{
			loadtile(i);

			if (write(fil,(char *)waloff[i],siz) < siz)
				printf("SAVE UNSUCCESSFUL!\n");
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}
